
IncludeScript("sprinklesscripts/lib/sprinkles_util.nut")
IncludeScript("give_tf_weapon/_master.nut")

Mystery_box_model <- EntityGroup[0];
Mystery_box_weapon_model <- EntityGroup[1];
Mystery_box_button <- EntityGroup[2];

m_iRollingDecel <- 0;
m_hButtonCaller <- null;
m_bEnableRolling <- false;
m_bEnableDecay <- false;
m_bEnableDecayAnimation <- false;
m_flRollingTime <- Time();
m_flRollingTimePickDelay <- Time();
m_flDecayTimer <- Time();
m_flDecayTimerAnimation <- Time();
m_aPickedArray <- [];

m_hFakeProp <- null;
m_aWeaponList <- [
	//*
	//NAME,WEAPONMODEL,SKIN,OFFSET
	//scout
	["Scattergun", "models/weapons/c_models/c_scattergun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Force-A-Nature", "models/weapons/c_models/c_double_barrel.mdl", 0 , Vector(0, 0, 0)], //force a nature
	["Shortstop", "models/workshop/weapons/c_models/c_shortstop/c_shortstop.mdl", 0 , Vector(0, 0, 0)], //shortstop
	["Soda Popper", "models/workshop/weapons/c_models/c_soda_popper/c_soda_popper.mdl", 0 , Vector(0, 0, 0)], //soda popper
	["Baby Face's Blaster", "models/workshop/weapons/c_models/c_pep_scattergun/c_pep_scattergun.mdl", 0 , Vector(0, 0, 0)], //Baby Face's Blaster
	["Back Scatter", "models/workshop/weapons/c_models/c_scatterdrum/c_scatterdrum.mdl", 0 , Vector(0, 0, 0)], //Baby Face's Blaster
	["Pistol", "models/weapons/c_models/c_pistol/c_pistol.mdl", 0 , Vector(0, 0, 0)], //pistol
	["Bonk! Atomic Punch", "models/weapons/c_models/c_energy_drink/c_energy_drink.mdl", 0 , Vector(0, 0, 0)], //bonk!
	["Lugermorph", "models/workshop/weapons/c_models/c_ttg_max_gun/c_ttg_max_gun.mdl", 0 , Vector(0, 0, 0)], //lugermorph
	["Crit-a-Cola", "models/weapons/c_models/c_energy_drink/c_energy_drink.mdl", 2 , Vector(0, 0, 0)], //crit a cola
	["Mad Milk", "models/workshop/weapons/c_models/c_madmilk/c_madmilk.mdl", 0 , Vector(0, 0, 0)], //mad milk
	["Winger", "models/workshop/weapons/c_models/c_winger_pistol/c_winger_pistol.mdl", 0 , Vector(0, 0, 0)], //winger
	["Pretty Boy's Pocket Pistol", "models/workshop/weapons/c_models/c_pep_pistol/c_pep_pistol.mdl", 0 , Vector(0, 0, 0)], //PBPP
	["Flying Guillotine", "models/workshop_partner/weapons/c_models/c_sd_cleaver/c_sd_cleaver.mdl", 0 , Vector(0, 0, 0)], //cleaver duh
	//soldier
	["Rocket Launcher", "models/weapons/c_models/c_rocketlauncher/c_rocketlauncher.mdl", 0 , Vector(0, 0, 0)], //rocket launcher
	["Direct Hit", "models/weapons/c_models/c_directhit/c_directhit.mdl", 0 , Vector(0, 0, 0)], //direct hit
	["Black Box", "models/workshop/weapons/c_models/c_blackbox/c_blackbox.mdl", 0 , Vector(0, 0, 0)], //blackbox
	["Rocket Jumper", "models/weapons/c_models/c_rocketjumper/c_rocketjumper.mdl", 0 , Vector(0, 0, 0)], //rocket jumper
	["Liberty Launcher", "models/workshop/weapons/c_models/c_liberty_launcher/c_liberty_launcher.mdl", 0 , Vector(0, 0, 0)], //freedom launcher
	["Cow Mangler 5000", "models/workshop/weapons/c_models/c_drg_cowmangler/c_drg_cowmangler.mdl", 0 , Vector(0, 0, 0)], //cow mangaler
	["Original", "models/workshop_partner/weapons/c_models/c_bet_rocketlauncher/c_bet_rocketlauncher.mdl", 0 , Vector(0, 0, 0)], //Original
	["Beggar's Bazooka", "models/workshop/weapons/c_models/c_dumpster_device/c_dumpster_device.mdl", 0 , Vector(0, 0, 0)], //Beggar's Bazooka
	["Air Strike", "models/workshop/weapons/c_models/c_atom_launcher/c_atom_launcher.mdl", 0 , Vector(0, 0, 0)], //airstrike
	["Shotgun", "models/weapons/c_models/c_shotgun/c_shotgun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Buff Banner", "models/weapons/c_models/c_buffpack/c_buffpack.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Battalion's Backup", "models/workshop/weapons/c_models/c_battalion_buffpack/c_battalion_buffpack.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Concheror", "models/workshop_partner/weapons/c_models/c_shogun_warpack/c_shogun_warpack.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["B.A.S.E. Jumper", "models/workshop/weapons/c_models/c_paratooper_pack/c_paratrooper_pack.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Reserve Shooter", "models/workshop/weapons/c_models/c_reserve_shooter/c_reserve_shooter.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Righteous Bison", "models/workshop/weapons/c_models/c_drg_righteousbison/c_drg_righteousbison.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Panic Attack", "models/workshop/weapons/c_models/c_trenchgun/c_trenchgun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Pyro
	["Flamethrower", "models/weapons/c_models/c_flamethrower/c_flamethrower.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Backburner", "models/weapons/c_models/c_flamethrower/c_backburner.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Degreaser", "models/workshop/weapons/c_models/c_degreaser/c_degreaser.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Phlogistinator", "models/workshop/weapons/c_models/c_drg_phlogistinator/c_drg_phlogistinator.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Rainblower", "models/weapons/c_models/c_flamethrower/c_flamethrower.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Dragon's Fury", "models/weapons/c_models/c_flameball/c_flameball.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Nostromo Napalmer", "models/workshop_partner/weapons/c_models/c_ai_flamethrower/c_ai_flamethrower.mdl", 0 , Vector(-20, 0, 0)], //scattergun
	["Flare Gun", "models/weapons/c_models/c_flaregun_pyro/c_flaregun_pyro.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Detonator", "models/workshop/weapons/c_models/c_detonator/c_detonator.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Manmelter", "models/workshop/weapons/c_models/c_drg_manmelter/c_drg_manmelter.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Scorch Shot", "models/workshop/weapons/c_models/c_scorch_shot/c_scorch_shot.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Thermal Thruster", "models/weapons/c_models/c_rocketpack/c_rocketpack.mdl", 0 , Vector(64, 0, 0)], //scattergun
	["Gas Passer", "models/weapons/c_models/c_gascan/c_gascan.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Demoman
	["Grenade Launcher", "models/weapons/c_models/c_grenadelauncher/c_grenadelauncher.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Loch-n-Load", "models/workshop/weapons/c_models/c_lochnload/c_lochnload.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Loose Cannon", "models/workshop/weapons/c_models/c_demo_cannon/c_demo_cannon.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Iron Bomber", "models/workshop/weapons/c_models/c_quadball/c_quadball.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Stickybomb Launcher", "models/weapons/c_models/c_stickybomb_launcher/c_stickybomb_launcher.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Scottish Resistance", "models/weapons/c_models/c_scottish_resistance/c_scottish_resistance.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Sticky Jumper", "models/weapons/c_models/c_sticky_jumper/c_sticky_jumper.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Quickiebomb Launcher", "models/workshop/weapons/c_models/c_kingmaker_sticky/c_kingmaker_sticky.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Heavy
	["Minigun", "models/weapons/c_models/c_minigun/c_minigun.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Natascha", "models/weapons/c_models/c_minigun/c_minigun_natascha.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Iron Curtain", "models/workshop/weapons/c_models/c_iron_curtain/c_iron_curtain.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Brass Beast", "models/workshop/weapons/c_models/c_gatling_gun/c_gatling_gun.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Tomislav", "models/workshop/weapons/c_models/c_tomislav/c_tomislav.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Huo-Long Heater", "models/workshop_partner/weapons/c_models/c_canton/c_canton.mdl", 0 , Vector(-24, 0, 8)], //scattergun
	["Family Business", "models/workshop/weapons/c_models/c_russian_riot/c_russian_riot.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Engineer
	["Frontier Justice", "models/weapons/c_models/c_frontierjustice/c_frontierjustice.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Widowmaker", "models/workshop_partner/weapons/c_models/c_dex_shotgun/c_dex_shotgun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Pomson 6000", "models/workshop/weapons/c_models/c_drg_pomson/c_drg_pomson.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Rescue Ranger", "models/workshop/weapons/c_models/c_tele_shotgun/c_tele_shotgun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Medic
	["Syringe Gun", "models/weapons/c_models/c_syringegun/c_syringegun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Blutsauger", "models/weapons/c_models/c_leechgun/c_leechgun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Crusader's Crossbow", "models/workshop/weapons/c_models/c_crusaders_crossbow/c_crusaders_crossbow.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Overdose", "models/weapons/c_models/c_proto_syringegun/c_proto_syringegun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Medi Gun", "models/weapons/c_models/c_medigun/c_medigun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Kritzkrieg", "models/weapons/c_models/c_medigun/c_medigun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Quick-Fix", "models/weapons/c_models/c_proto_medigun/c_proto_medigun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Vaccinator", "models/workshop/weapons/c_models/c_medigun_defense/c_medigun_defense.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//sniper
	["Sniper Rifle", "models/weapons/c_models/c_sniperrifle/c_sniperrifle.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Huntsman", "models/weapons/c_models/c_bow/c_bow.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Sydney Sleeper", "models/workshop/weapons/c_models/c_sydney_sleeper/c_sydney_sleeper.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Bazaar Bargain", "models/workshop/weapons/c_models/c_bazaar_sniper/c_bazaar_sniper.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Machina", "models/workshop_partner/weapons/c_models/c_dex_sniperrifle/c_dex_sniperrifle.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Hitman's Heatmaker", "models/workshop/weapons/c_models/c_pro_rifle/c_pro_rifle.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["AWPer Hand", "models/weapons/c_models/c_csgo_awp/c_csgo_awp.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Fortified Compound", "models/workshop_partner/weapons/c_models/c_bow_thief/c_bow_thief.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Classic", "models/weapons/c_models/c_tfc_sniperrifle/c_tfc_sniperrifle.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Shooting Star", "models/workshop/weapons/c_models/c_invasion_sniperrifle/c_invasion_sniperrifle.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["SMG", "models/weapons/c_models/c_smg/c_smg.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Razorback", "models/player/items/sniper/knife_shield.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Jarate", "models/weapons/c_models/urinejar.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["DDS", "models/workshop/player/items/sniper/croc_shield/croc_shield.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Cozy Camper", "models/workshop/player/items/sniper/xms_sniper_commandobackpack/xms_sniper_commandobackpack.mdl", 0 , Vector(16, 0, -64)], //scattergun
	["Cleaner's Carbine", "models/workshop/weapons/c_models/c_pro_smg/c_pro_smg.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//Spy
	["Revolver", "models/weapons/c_models/c_revolver/c_revolver.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Ambassador", "models/weapons/c_models/c_ambassador/c_ambassador.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Big Kill", "models/workshop/weapons/c_models/c_ttg_sam_gun/c_ttg_sam_gun.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["L'Etranger", "models/workshop/weapons/c_models/c_letranger/c_letranger.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Enforcer", "models/workshop/weapons/c_models/c_snub_nose/c_snub_nose.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Diamondback", "models/workshop_partner/weapons/c_models/c_dex_revolver/c_dex_revolver.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Knife", "models/weapons/c_models/c_knife/c_knife.mdl", 0 , Vector(0, 0, 0)], //scattergun
	["Black Rose", "models/workshop/weapons/c_models/c_ava_roseknife/c_ava_roseknife.mdl", 0 , Vector(0, 0, 0)], //scattergun
	//*/
]

function Precache()
{
    self.PrecacheModel("models/editor/axis_helper.mdl");
	self.PrecacheModel("models/empty.mdl");
    self.PrecacheModel("models/props_halloween/merasmus_skull_island.mdl");
    self.PrecacheScriptSound("ui/itemcrate_smash_ultrarare_fireworks.wav");
    self.PrecacheScriptSound("ui/item_open_crate_short.wav");
    self.PrecacheScriptSound("Player.Puff");
	m_hFakeProp = CreateProp("prop_dynamic", Mystery_box_weapon_model.GetOrigin(), "models/editor/axis_helper.mdl", 0)
}

function OnPostSpawn()
{
	EntFire( Mystery_box_weapon_model.GetName(), "SetParentAttachment", "1", 1.0,  null );	//
	EntFireByHandle(m_hFakeProp, "SetParent", Mystery_box_model.GetName(), 0.1, null, null);
	EntFireByHandle(m_hFakeProp, "SetParentAttachment", "1", 1.0, null, null);
	//Mystery_box_weapon_model.SetModel("models/weapons/c_models/c_double_barrel.mdl")
	SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
	AddThinkToEnt(self, "Think")
	m_hFakeProp.SetModel("models/empty.mdl")
}

function ButtonPress()
{
	m_hButtonCaller = activator
	EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_start", 0.0,  null );	//
	EmitSoundEx({
		sound_name = "ui/item_open_crate_short.wav",
		origin = Mystery_box_model.GetCenter(),
		volume = 1.0,
		channel = 6,
		sound_level = 100
	});
	m_flRollingTime = Time() + 5
	m_bEnableRolling = true;
	EntFireByHandle(self, "RunScriptCode", "WeaponSoundAwareded()", 2, null, null);
}

function WeaponSoundAwareded()
{
	EmitSoundEx({
		sound_name = "ui/itemcrate_smash_ultrarare_fireworks.wav",
		origin = Mystery_box_model.GetCenter(),
		volume = 1.0,
		channel = 6,
		sound_level = 100
	});
}

function WeaponPress()
{
	if (m_hButtonCaller == activator)
	{
		m_bEnableDecay = false
		EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_end", 0.0,  null );	//
		SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
		Mystery_box_weapon_model.SetModel("models/empty.mdl")
		EntFireByHandle(Mystery_box_button, "Pressout", "", 4, null, null);
		//m_hButtonCaller.GiveWeapon("Rocket Jumper");
		m_hButtonCaller.GiveWeapon(m_aPickedArray[0])
		m_hButtonCaller = null
	}
}

function Think()
{
	if(m_bEnableRolling)
	{
		if(m_flRollingTimePickDelay < Time())
		{
			local RandomPick = RandomInt(0, m_aWeaponList.len()-1 );	// pick a gun from the weapon list
			m_aPickedArray = m_aWeaponList[RandomPick];

			Mystery_box_weapon_model.AcceptInput("SetParentAttachment", "1", null,null)
			Mystery_box_weapon_model.SetAbsOrigin(m_hFakeProp.GetOrigin() + m_aPickedArray[3])
			Mystery_box_weapon_model.SetModel(m_aPickedArray[1])
			Mystery_box_weapon_model.SetSkin(m_aPickedArray[2])
			if(m_flRollingTime < Time())
			{
				printl(m_iRollingDecel)
				m_bEnableRolling = false;
				SetPropInt(Mystery_box_weapon_model, "m_takedamage", 1)
				m_flDecayTimer = Time() + 16.5
				m_flDecayTimerAnimation = Time() + 12.5
				m_bEnableDecay = true;
				m_bEnableDecayAnimation = true;
				m_iRollingDecel = 0
			}
			m_flRollingTimePickDelay = Time() + RemapVal( m_iRollingDecel,  0,  350,  0.01,  0.3)
		}
		m_iRollingDecel++
	}

	if(m_bEnableDecay)
	{
		if(m_bEnableDecayAnimation)
		{
			if(m_flDecayTimerAnimation < Time())
			{
				m_bEnableDecayAnimation = false
				EntFire( Mystery_box_model.GetName(), "SetAnimation", "open_end", 0,  null );	//
			}
		}

		if(m_flDecayTimer < Time())
		{
			m_bEnableDecay = false;
			m_flDecayTimer = Time()
			m_flRollingTime = Time()
			Mystery_box_weapon_model.SetModel("models/empty.mdl")
			Mystery_box_model.EmitSound("Player.Puff")
			EntFireByHandle(Mystery_box_button, "Pressout", "", 0.5, null, null);
			SetPropInt(Mystery_box_weapon_model, "m_takedamage", 0)
		}
	}
	return -1
}

local EventsID = UniqueString()
getroottable()[EventsID] <-
{
	// Cleanup events on round restart. Do not remove this event.
	OnGameEvent_scorestats_accumulated_update = function(params) { delete getroottable()[EventsID] }

	////////// Add your events here //////////////

    OnGameEvent_post_inventory_application = function(params)
    {
        if (!("userid" in params)) return;
		//Defines player handle as hPlayer
			local hPlayer = GetPlayerFromUserID(params.userid);

		// REQUIRED ( Must be at the beginning! )
			hPlayer.GTFW_Cleanup();	// Anytime a weapon or wearable is created, it won't delete by itself!! This function will remove those entities for you.


		// OPTIONAL
		// - LOADOUTS
		//	 This feature is for if you want to save and load player loadouts.
		//	 Without this generally what happens is after you give a weapon, resupply will just delete it completely and not give it back.
		//	 This fixes that!
			EntFireByHandle(hPlayer,"RunScriptCode","self.LoadLoadout()",0.0,hPlayer,hPlayer);

		// - CUSTOM CLASS ARMS FOR FIRST-PERSON
		//	 As it says on the tin. This one is only if you want to restore custom class arms after touching resupply.
		//	 You can set custom arms with function hPlayer.SetCustomClassArms(my_model_path, true)
		//	  If you set param 2 to `true`, it'll save the arms in memory to be loaded by the below function.
		//	  Otherwise, setting to `false` or just not including it won't save it in memory. It'll only last until GTFW_Cleanup() removes it.
			EntFireByHandle(hPlayer,"RunScriptCode","self.GTFW_RestoreCustomClassArms()",0.0,hPlayer,hPlayer);
    }

	OnGameEvent_player_death = function(params)
    {
		if (!("userid" in params)) return;

		//Defines player handle as hPlayer
			local hPlayer = GetPlayerFromUserID(params.userid);
		// Updates ragdoll to the player's actual class.
			//GTFW.SetUseClassAnimations_OFF(hPlayer)
    }
}
local EventsTable = getroottable()[EventsID]
foreach (name, callback in EventsTable) EventsTable[name] = callback.bindenv(this)
__CollectGameEventCallbacks(EventsTable)
